'****************************************************************************
' Name:        DFTTSSampleVB.NET with DFTTS Desktop SDK v 3.5.0
' Purpose:
' Author:      Digital Future
' Modified by:
' Created:     06/26/2008, updated 7/21/2008
' RCS-ID:
' Copyright:   (C) Digital Future 2007-2008. All rights reserved.
' Licence:     see license document
'***************************************************************************/

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.Diagnostics
Imports System.Security.Permissions

Public Class Form1

#Region "API Enums and Constants"

    Public Const NEOSPEECH_NUM_VOICES As Integer = 12

    Public Const NUM_ENGINE_INITIALIZATIONS As Integer = 16

    Public Enum DFTTSPredefinedSpeechParams

        DF_TTS_DEFAULT_PITCH = 100 '/*100%*/
        DF_TTS_DEFAULT_SPEED = 100 '/*100%*/
        DF_TTS_DEFAULT_VOLUME = 100 '/*100%*/
        DF_TTS_DEFAULT_PAUSE = 670 '/*670 msec*/
        DF_TTS_NEOSPEECH_MIN_PITCH = 50
        DF_TTS_NEOSPEECH_MAX_PITCH = 200
        DF_TTS_NEOSPEECH_MIN_SPEED = 50
        DF_TTS_NEOSPEECH_MAX_SPEED = 400
        DF_TTS_NEOSPEECH_MIN_VOLUME = 0
        DF_TTS_NEOSPEECH_MAX_VOLUME = 500
        DF_TTS_NEOSPEECH_MIN_PAUSE = 0
        DF_TTS_NEOSPEECH_MAX_PAUSE = 20000
        DF_TTS_CEPSTRAL_MIN_PITCH = 100
        DF_TTS_CEPSTRAL_MAX_PITCH = 500
        DF_TTS_CEPSTRAL_MIN_SPEED = 0
        DF_TTS_CEPSTRAL_MAX_SPEED = 400
        DF_TTS_CEPSTRAL_MIN_VOLUME = 0
        DF_TTS_CEPSTRAL_MAX_VOLUME = 500
        DF_TTS_ATTNV_MIN_SPEED = 13
        DF_TTS_ATTNV_MAX_SPEED = 800
        DF_TTS_ATTNV_MIN_VOLUME = 0
        DF_TTS_ATTNV_MAX_VOLUME = 500
        DF_TTS_ATTNV_MIN_PITCH = 0 '/*AT&T NV do not support this*/
        DF_TTS_ATTNV_MAX_PITCH = 0 '/*AT&T NV do not support this*/
        DF_TTS_MACOSXSPMAN_MIN_PITCH = 1
        DF_TTS_MACOSXSPMAN_MAX_PITCH = 1000
        DF_TTS_MACOSXSPMAN_MIN_SPEED = 1
        DF_TTS_MACOSXSPMAN_MAX_SPEED = 1000
        DF_TTS_MACOSXSPMAN_MIN_VOLUME = 100
        DF_TTS_MACOSXSPMAN_MAX_VOLUME = 500
        DF_TTS_MSSAPI_MIN_PITCH = 30
        DF_TTS_MSSAPI_MAX_PITCH = 350
        DF_TTS_MSSAPI_MIN_SPEED = 30
        DF_TTS_MSSAPI_MAX_SPEED = 350
        DF_TTS_MSSAPI_MIN_VOLUME = 0
        DF_TTS_MSSAPI_MAX_VOLUME = 100

    End Enum

    Public Enum DFTTSVoiceEngineType

        NOENGINE = -4
        ALLENGINES = -3
        NEOSPEECHVOICETEXT = 0
        CEPSTRAL
        ATTNV
        MSSAPI
        MACOSXSPMAN

    End Enum

    Public Enum InitDFTTSEngineReturnValue

        INIT_DFTTS_ENGINE_SUCCESS
        INIT_DFTTS_ENGINE_ERROR_DB_PATH_DIFFERENT
        INIT_DFTTS_ENGINE_ERROR_CHANNEL_MEM_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_MORPHEME_ANALYSIS_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_BREAK_INDEX_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_TEXT_PREP_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_ACOU_MODEL_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_UNIT_SEL_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_PROS_MODEL_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_SPEECH_DB_FAIL
        INIT_DFTTS_ENGINE_ERROR_DB_PITCH_LOC_INFO_FAIL
        INIT_DFTTS_ENGINE_ERROR_FAILED
        INIT_DFTTS_ENGINE_ERROR_INVALIDARG
        INIT_DFTTS_ENGINE_ERROR_OUTOFMEMORY
        INIT_DFTTS_ENGINE_ERROR_NOTIMPL
        INIT_DFTTS_ENGINE_ERROR_ABORT
        INIT_DFTTS_ENGINE_ERROR_UNKNOWN
        INIT_DFTTS_ENGINE_ERROR_BADHANDLE
        INIT_DFTTS_ENGINE_ERROR_EXCEPTION
        INIT_DFTTS_ENGINE_ERROR_EMPTY
        INIT_DFTTS_ENGINE_ERROR_FULL
        INIT_DFTTS_ENGINE_ERROR_INVALIDSTATE
        INIT_DFTTS_ENGINE_ERROR_BADVERSION
        INIT_DFTTS_ENGINE_ERROR_INSUFFICIENT_BUFFER
        INIT_DFTTS_ENGINE_ERROR_UNSUPPORTED
        INIT_DFTTS_ENGINE_ERROR_NOLICENSE
        INIT_DFTTS_ENGINE_ERROR_CREATECHILDPROCESS_FAILED
        INIT_DFTTS_ENGINE_ERROR_NOENVIRONMENTPATH
        INIT_DFTTS_ENGINE_ERROR_TIMEOUT
        INIT_DFTTS_ENGINE_ERROR_OUTOFRESOURCES
        INIT_DFTTS_ENGINE_ERROR_NOVOICES
        INIT_DFTTS_ENGINE_ERROR_CREATEFAIL
        INIT_DFTTS_ENGINE_ERROR_CONNECTFAIL
        INIT_DFTTS_ENGINE_ERROR_BINDFAIL
        INIT_DFTTS_ENGINE_ERROR_LISTENFAIL
        INIT_DFTTS_ENGINE_ERROR_CONNECTIONCLOSED
        INIT_DFTTS_ENGINE_ERROR_ACCEPTFAIL
        INIT_DFTTS_ENGINE_ERROR_SOCKETTIMEOUT
        INIT_DFTTS_ENGINE_ERROR_SOCKETERROR
        INIT_DFTTS_ENGINE_ERROR_NOMORESERVERS
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EWOULDBLOCK
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EINPROGRESS
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EALREADY
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTSOCK
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EDESTADDRREQ
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EMSGSIZE
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROTOTYPE
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOPROTOOPT
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROTONOSUPPORT
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ESOCKTNOSUPPORT
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EOPNOTSUPP
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EPFNOSUPPORT
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EAFNOSUPPORT
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EADDRINUSE
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EADDRNOTAVAIL
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETDOWN
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETUNREACH
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENETRESET
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNABORTED
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNRESET
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOBUFS
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EISCONN
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTCONN
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ESHUTDOWN
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ETOOMANYREFS
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ECONNREFUSED
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ELOOP
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENAMETOOLONG
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EHOSTDOWN
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EHOSTUNREACH
        INIT_DFTTS_ENGINE_ERROR_SOCKET_ENOTEMPTY
        INIT_DFTTS_ENGINE_ERROR_SOCKET_EPROCLIM
        INIT_DFTTS_ENGINE_ERROR_THREADSTARTED
        INIT_DFTTS_ENGINE_ERROR_THREADNOTSTARTED
        INIT_DFTTS_ENGINE_ERROR_THREADCOULDNOTCREATE
        INIT_DFTTS_ENGINE_ERROR_BADNVFILE
        INIT_DFTTS_ENGINE_ERROR_NOAUDIODRIVER
        INIT_DFTTS_ENGINE_ERROR_DICTNOTFOUND
        INIT_DFTTS_ENGINE_ERROR_OTHER

    End Enum

    Public Enum UninitDFTTSEngineReturnValue

        UNINIT_DFTTS_ENGINE_SUCCESS
        UNINIT_DFTTS_ENGINE_FAIL

    End Enum

    Public Enum LoadDFTTSUserDictReturnValue

        LOAD_USER_DICT_SUCCESS
        LOAD_USER_DICT_ERROR_DICTIDX_NOT_VALID
        LOAD_USER_DICT_ERROR_DICT_ALREADY_LOADED
        LOAD_USER_DICT_ERROR_DICT_WORD_ALREADY_LOADED
        LOAD_USER_DICT_ERROR_NO_DICT_FILE_OR_ENTRY
        LOAD_USER_DICT_ERROR_INVALID_DICT_FILE
        LOAD_USER_DICT_ERROR_INVALID_VOICE
        LOAD_USER_DICT_ERROR_INVALID_ARG
        LOAD_USER_DICT_ERROR_INVALID_PHONEME_SET
        LOAD_USER_DICT_ERROR_INVALID_PHONEME
        LOAD_USER_DICT_ERROR_INVALID_PARTOFSP
        LOAD_USER_DICT_ERROR_DENIED
        LOAD_USER_DICT_ERROR_OUTOFMEMORY
        LOAD_USER_DICT_ERROR_INTERNAL
        LOAD_USER_DICT_ERROR_OTHER

    End Enum


    Public Enum UnloadDFTTSUserDictReturnValue

        UNLOAD_USER_DICT_SUCCESS
        UNLOAD_USER_DICT_ERROR_DICTIDX_NOT_VALID
        UNLOAD_USER_DICT_ERROR_DICT_UNLOADED
        UNLOAD_USER_DICT_ERROR_NO_DICT_FILE_OR_ENTRY
        UNLOAD_USER_DICT_ERROR_INVALID_PARTOFSP
        UNLOAD_USER_DICT_ERROR_INVALID_PHONEME_SET
        UNLOAD_USER_DICT_ERROR_INTERNAL
        UNLOAD_USER_DICT_ERROR_OTHER

    End Enum

    Public Enum DFTTSTextType

        DFTTS_TEXT_TYPE_PLAIN
        DFTTS_TEXT_TYPE_XML

    End Enum

    Public Enum DFTTSSpeakReturnValue

        DFTTS_SPEAK_SUCCESS
        DFTTS_SPEAK_ERROR_CHANNEL_MEM_FAIL
        DFTTS_SPEAK_ERROR_TEXT_NULL
        DFTTS_SPEAK_ERROR_TEXT_ZERO_LEN
        DFTTS_SPEAK_ERROR_DB_NOT_LOADED
        DFTTS_SPEAK_ERROR_SET_SOUND_CARD_FAIL
        DFTTS_SPEAK_ERROR_UNIMPLEMENTED
        DFTTS_SPEAK_ERROR_INTERNAL
        DFTTS_SPEAK_ERROR_INVALID_PARAM
        DFTTS_SPEAK_ERROR_INVALID_POINTER
        DFTTS_SPEAK_ERROR_UNKNOWN_ENCODING
        DFTTS_SPEAK_ERROR_OBJECT_NOT_FOUND
        DFTTS_SPEAK_ERROR_INTERRUPTED
        DFTTS_SPEAK_ERROR_INVALID_VOICE
        DFTTS_SPEAK_ERROR_WRONG_EVENT
        DFTTS_SPEAK_ERROR_ENGINE_INUSE
        DFTTS_SPEAK_ERROR_NETWORK_ERROR
        DFTTS_SPEAK_ERROR_INVALID_KEY
        DFTTS_SPEAK_ERROR_QUEUE_FULL
        DFTTS_SPEAK_ERROR_TOKEN_TIMEOUT
        DFTTS_SPEAK_ERROR_FAILED
        DFTTS_SPEAK_ERROR_INVALIDARG
        DFTTS_SPEAK_ERROR_OUTOFMEMORY
        DFTTS_SPEAK_ERROR_NOTIMPL
        DFTTS_SPEAK_ERROR_ABORT
        DFTTS_SPEAK_ERROR_UNKNOWN
        DFTTS_SPEAK_ERROR_BADHANDLE
        DFTTS_SPEAK_ERROR_EXCEPTION
        DFTTS_SPEAK_ERROR_EMPTY
        DFTTS_SPEAK_ERROR_FULL
        DFTTS_SPEAK_ERROR_INVALIDSTATE
        DFTTS_SPEAK_ERROR_BADVERSION
        DFTTS_SPEAK_ERROR_INSUFFICIENT_BUFFER
        DFTTS_SPEAK_ERROR_UNSUPPORTED
        DFTTS_SPEAK_ERROR_NOLICENSE
        DFTTS_SPEAK_ERROR_CREATECHILDPROCESS_FAILED
        DFTTS_SPEAK_ERROR_NOENVIRONMENTPATH
        DFTTS_SPEAK_ERROR_TIMEOUT
        DFTTS_SPEAK_ERROR_OUTOFRESOURCES
        DFTTS_SPEAK_ERROR_NOVOICES
        DFTTS_SPEAK_ERROR_CREATEFAIL
        DFTTS_SPEAK_ERROR_CONNECTFAIL
        DFTTS_SPEAK_ERROR_BINDFAIL
        DFTTS_SPEAK_ERROR_LISTENFAIL
        DFTTS_SPEAK_ERROR_CONNECTIONCLOSED
        DFTTS_SPEAK_ERROR_ACCEPTFAIL
        DFTTS_SPEAK_ERROR_SOCKETTIMEOUT
        DFTTS_SPEAK_ERROR_SOCKETERROR
        DFTTS_SPEAK_ERROR_NOMORESERVERS
        DFTTS_SPEAK_ERROR_SOCKET_EWOULDBLOCK
        DFTTS_SPEAK_ERROR_SOCKET_EINPROGRESS
        DFTTS_SPEAK_ERROR_SOCKET_EALREADY
        DFTTS_SPEAK_ERROR_SOCKET_ENOTSOCK
        DFTTS_SPEAK_ERROR_SOCKET_EDESTADDRREQ
        DFTTS_SPEAK_ERROR_SOCKET_EMSGSIZE
        DFTTS_SPEAK_ERROR_SOCKET_EPROTOTYPE
        DFTTS_SPEAK_ERROR_SOCKET_ENOPROTOOPT
        DFTTS_SPEAK_ERROR_SOCKET_EPROTONOSUPPORT
        DFTTS_SPEAK_ERROR_SOCKET_ESOCKTNOSUPPORT
        DFTTS_SPEAK_ERROR_SOCKET_EOPNOTSUPP
        DFTTS_SPEAK_ERROR_SOCKET_EPFNOSUPPORT
        DFTTS_SPEAK_ERROR_SOCKET_EAFNOSUPPORT
        DFTTS_SPEAK_ERROR_SOCKET_EADDRINUSE
        DFTTS_SPEAK_ERROR_SOCKET_EADDRNOTAVAIL
        DFTTS_SPEAK_ERROR_SOCKET_ENETDOWN
        DFTTS_SPEAK_ERROR_SOCKET_ENETUNREACH
        DFTTS_SPEAK_ERROR_SOCKET_ENETRESET
        DFTTS_SPEAK_ERROR_SOCKET_ECONNABORTED
        DFTTS_SPEAK_ERROR_SOCKET_ECONNRESET
        DFTTS_SPEAK_ERROR_SOCKET_ENOBUFS
        DFTTS_SPEAK_ERROR_SOCKET_EISCONN
        DFTTS_SPEAK_ERROR_SOCKET_ENOTCONN
        DFTTS_SPEAK_ERROR_SOCKET_ESHUTDOWN
        DFTTS_SPEAK_ERROR_SOCKET_ETOOMANYREFS
        DFTTS_SPEAK_ERROR_SOCKET_ECONNREFUSED
        DFTTS_SPEAK_ERROR_SOCKET_ELOOP
        DFTTS_SPEAK_ERROR_SOCKET_ENAMETOOLONG
        DFTTS_SPEAK_ERROR_SOCKET_EHOSTDOWN
        DFTTS_SPEAK_ERROR_SOCKET_EHOSTUNREACH
        DFTTS_SPEAK_ERROR_SOCKET_ENOTEMPTY
        DFTTS_SPEAK_ERROR_SOCKET_EPROCLIM
        DFTTS_SPEAK_ERROR_THREADSTARTED
        DFTTS_SPEAK_ERROR_THREADNOTSTARTED
        DFTTS_SPEAK_ERROR_THREADCOULDNOTCREATE
        DFTTS_SPEAK_ERROR_BADNVFILE
        DFTTS_SPEAK_ERROR_NOAUDIODRIVER
        DFTTS_SPEAK_ERROR_DICTNOTFOUND
        DFTTS_SPEAK_ERROR_ALREADYPLAYING
        DFTTS_SPEAK_ERROR_AUDIOFORMATNOTSUPPORTED
        DFTTS_SPEAK_ERROR_XML_INVALID
        DFTTS_SPEAK_ERROR_WL_INVALID
        DFTTS_SPEAK_ERROR_INVALIDPHONESET
        DFTTS_SPEAK_ERROR_INVALIDPHONEME
        DFTTS_SPEAK_ERROR_MSGQ_CREATEFAILED
        DFTTS_SPEAK_ERROR_MSGQ_ALREADYEXISTS
        DFTTS_SPEAK_ERROR_MSGQ_NOTFOUND
        DFTTS_SPEAK_ERROR_MSGQ_INVALIDOP
        DFTTS_SPEAK_ERROR_MSGQ_NOTOPEN
        DFTTS_SPEAK_ERROR_MSGQ_LOCKFAILED
        DFTTS_SPEAK_ERROR_MSGQ_ABANDONED
        DFTTS_SPEAK_ERROR_MSGQ_OPENFAILED
        DFTTS_SPEAK_ERROR_OTHER

    End Enum


    Public Enum DFTTSPauseReturnValue

        DFTTS_PAUSE_SUCCESS
        DFTTS_PAUSE_ERROR_UNIMPLEMENTED
        DFTTS_PAUSE_ERROR_INTERNAL
        DFTTS_PAUSE_ERROR_INVALID_PARAM
        DFTTS_PAUSE_ERROR_INVALID_POINTER
        DFTTS_PAUSE_ERROR_OBJECT_NOT_FOUND
        DFTTS_PAUSE_ERROR_UNKNOWN_ENCODING
        DFTTS_PAUSE_ERROR_INTERRUPTED
        DFTTS_PAUSE_ERROR_INVALID_VOICE
        DFTTS_PAUSE_ERROR_WRONG_EVENT
        DFTTS_PAUSE_ERROR_ENGINE_INUSE
        DFTTS_PAUSE_ERROR_NETWORK_ERROR
        DFTTS_PAUSE_ERROR_INVALID_KEY
        DFTTS_PAUSE_ERROR_QUEUE_FULL
        DFTTS_PAUSE_ERROR_TOKEN_TIMEOUT
        DFTTS_PAUSE_ERROR_OTHER

    End Enum


    Public Enum DFTTSResumeReturnValue

        DFTTS_RESUME_SUCCESS
        DFTTS_RESUME_ERROR_UNIMPLEMENTED
        DFTTS_RESUME_ERROR_INTERNAL
        DFTTS_RESUME_ERROR_INVALID_PARAM
        DFTTS_RESUME_ERROR_INVALID_POINTER
        DFTTS_RESUME_ERROR_OBJECT_NOT_FOUND
        DFTTS_RESUME_ERROR_UNKNOWN_ENCODING
        DFTTS_RESUME_ERROR_INTERRUPTED
        DFTTS_RESUME_ERROR_INVALID_VOICE
        DFTTS_RESUME_ERROR_WRONG_EVENT
        DFTTS_RESUME_ERROR_ENGINE_INUSE
        DFTTS_RESUME_ERROR_NETWORK_ERROR
        DFTTS_RESUME_ERROR_INVALID_KEY
        DFTTS_RESUME_ERROR_QUEUE_FULL
        DFTTS_RESUME_ERROR_TOKEN_TIMEOUT
        DFTTS_RESUME_ERROR_FAILED
        DFTTS_RESUME_ERROR_INVALIDARG
        DFTTS_RESUME_ERROR_OUTOFMEMORY
        DFTTS_RESUME_ERROR_NOTIMPL
        DFTTS_RESUME_ERROR_ABORT
        DFTTS_RESUME_ERROR_UNKNOWN
        DFTTS_RESUME_ERROR_BADHANDLE
        DFTTS_RESUME_ERROR_EXCEPTION
        DFTTS_RESUME_ERROR_EMPTY
        DFTTS_RESUME_ERROR_FULL
        DFTTS_RESUME_ERROR_INVALIDSTATE
        DFTTS_RESUME_ERROR_BADVERSION
        DFTTS_RESUME_ERROR_INSUFFICIENT_BUFFER
        DFTTS_RESUME_ERROR_UNSUPPORTED
        DFTTS_RESUME_ERROR_NOLICENSE
        DFTTS_RESUME_ERROR_CREATECHILDPROCESS_FAILED
        DFTTS_RESUME_ERROR_NOENVIRONMENTPATH
        DFTTS_RESUME_ERROR_TIMEOUT
        DFTTS_RESUME_ERROR_OUTOFRESOURCES
        DFTTS_RESUME_ERROR_NOVOICES
        DFTTS_RESUME_ERROR_CREATEFAIL
        DFTTS_RESUME_ERROR_CONNECTFAIL
        DFTTS_RESUME_ERROR_BINDFAIL
        DFTTS_RESUME_ERROR_LISTENFAIL
        DFTTS_RESUME_ERROR_CONNECTIONCLOSED
        DFTTS_RESUME_ERROR_ACCEPTFAIL
        DFTTS_RESUME_ERROR_SOCKETTIMEOUT
        DFTTS_RESUME_ERROR_SOCKETERROR
        DFTTS_RESUME_ERROR_NOMORESERVERS
        DFTTS_RESUME_ERROR_SOCKET_EWOULDBLOCK
        DFTTS_RESUME_ERROR_SOCKET_EINPROGRESS
        DFTTS_RESUME_ERROR_SOCKET_EALREADY
        DFTTS_RESUME_ERROR_SOCKET_ENOTSOCK
        DFTTS_RESUME_ERROR_SOCKET_EDESTADDRREQ
        DFTTS_RESUME_ERROR_SOCKET_EMSGSIZE
        DFTTS_RESUME_ERROR_SOCKET_EPROTOTYPE
        DFTTS_RESUME_ERROR_SOCKET_ENOPROTOOPT
        DFTTS_RESUME_ERROR_SOCKET_EPROTONOSUPPORT
        DFTTS_RESUME_ERROR_SOCKET_ESOCKTNOSUPPORT
        DFTTS_RESUME_ERROR_SOCKET_EOPNOTSUPP
        DFTTS_RESUME_ERROR_SOCKET_EPFNOSUPPORT
        DFTTS_RESUME_ERROR_SOCKET_EAFNOSUPPORT
        DFTTS_RESUME_ERROR_SOCKET_EADDRINUSE
        DFTTS_RESUME_ERROR_SOCKET_EADDRNOTAVAIL
        DFTTS_RESUME_ERROR_SOCKET_ENETDOWN
        DFTTS_RESUME_ERROR_SOCKET_ENETUNREACH
        DFTTS_RESUME_ERROR_SOCKET_ENETRESET
        DFTTS_RESUME_ERROR_SOCKET_ECONNABORTED
        DFTTS_RESUME_ERROR_SOCKET_ECONNRESET
        DFTTS_RESUME_ERROR_SOCKET_ENOBUFS
        DFTTS_RESUME_ERROR_SOCKET_EISCONN
        DFTTS_RESUME_ERROR_SOCKET_ENOTCONN
        DFTTS_RESUME_ERROR_SOCKET_ESHUTDOWN
        DFTTS_RESUME_ERROR_SOCKET_ETOOMANYREFS
        DFTTS_RESUME_ERROR_SOCKET_ECONNREFUSED
        DFTTS_RESUME_ERROR_SOCKET_ELOOP
        DFTTS_RESUME_ERROR_SOCKET_ENAMETOOLONG
        DFTTS_RESUME_ERROR_SOCKET_EHOSTDOWN
        DFTTS_RESUME_ERROR_SOCKET_EHOSTUNREACH
        DFTTS_RESUME_ERROR_SOCKET_ENOTEMPTY
        DFTTS_RESUME_ERROR_SOCKET_EPROCLIM
        DFTTS_RESUME_ERROR_THREADSTARTED
        DFTTS_RESUME_ERROR_THREADNOTSTARTED
        DFTTS_RESUME_ERROR_THREADCOULDNOTCREATE
        DFTTS_RESUME_ERROR_BADNVFILE
        DFTTS_RESUME_ERROR_NOAUDIODRIVER
        DFTTS_RESUME_ERROR_DICTNOTFOUND
        DFTTS_RESUME_ERROR_ALREADYPLAYING
        DFTTS_RESUME_ERROR_AUDIOFORMATNOTSUPPORTED
        DFTTS_RESUME_ERROR_XML_INVALID
        DFTTS_RESUME_ERROR_WL_INVALID
        DFTTS_RESUME_ERROR_INVALIDPHONESET
        DFTTS_RESUME_ERROR_INVALIDPHONEME
        DFTTS_RESUME_ERROR_MSGQ_CREATEFAILED
        DFTTS_RESUME_ERROR_MSGQ_ALREADYEXISTS
        DFTTS_RESUME_ERROR_MSGQ_NOTFOUND
        DFTTS_RESUME_ERROR_MSGQ_INVALIDOP
        DFTTS_RESUME_ERROR_MSGQ_NOTOPEN
        DFTTS_RESUME_ERROR_MSGQ_LOCKFAILED
        DFTTS_RESUME_ERROR_MSGQ_ABANDONED
        DFTTS_RESUME_ERROR_MSGQ_OPENFAILED
        DFTTS_RESUME_ERROR_NOTHING_TO_RESUME
        DFTTS_RESUME_ERROR_OTHER


    End Enum

    Public Enum DFTTSStopReturnValue

        DFTTS_STOP_SUCCESS
        DFTTS_STOP_ERROR_INVALID_POINTER
        DFTTS_STOP_ERROR_INVALID_ARG
        DFTTS_STOP_ERROR_OUT_OF_MEMORY
        DFTTS_STOP_ERROR_INVALID_FLAGS
        DFTTS_STOP_ERROR_ENGINE_INUSE
        DFTTS_STOP_ERROR_OTHER

    End Enum

    Public Enum DFTTSExportReturnValue

        DFTTS_EXPORT_SUCCESS
        DFTTS_EXPORT_ERROR_FORMAT_NOT_SUPPORTED
        DFTTS_EXPORT_ERROR_CHANNEL_MEM_FAIL
        DFTTS_EXPORT_ERROR_TEXT_NULL
        DFTTS_EXPORT_ERROR_TEXT_ZERO_LEN
        DFTTS_EXPORT_ERROR_DB_NOT_LOADED
        DFTTS_EXPORT_ERROR_GEN_FILE_FAIL
        DFTTS_EXPORT_ERROR_BUFFER_NULL
        DFTTS_EXPORT_ERROR_THREAD_IN_USE
        DFTTS_EXPORT_ERROR_UNIMPLEMENTED
        DFTTS_EXPORT_ERROR_INTERNAL
        DFTTS_EXPORT_ERROR_INVALID_PARAM
        DFTTS_EXPORT_ERROR_INVALID_POINTER
        DFTTS_EXPORT_ERROR_OBJECT_NOT_FOUND
        DFTTS_EXPORT_ERROR_UNKNOWN_ENCODING
        DFTTS_EXPORT_ERROR_INTERRUPTED
        DFTTS_EXPORT_ERROR_INVALID_VOICE
        DFTTS_EXPORT_ERROR_WRONG_EVENT
        DFTTS_EXPORT_ERROR_ENGINE_INUSE
        DFTTS_EXPORT_ERROR_NETWORK_ERROR
        DFTTS_EXPORT_ERROR_INVALID_KEY
        DFTTS_EXPORT_ERROR_QUEUE_FULL
        DFTTS_EXPORT_ERROR_TOKEN_TIMEOUT
        DFTTS_EXPORT_ERROR_FAILED
        DFTTS_EXPORT_ERROR_INVALIDARG
        DFTTS_EXPORT_ERROR_OUTOFMEMORY
        DFTTS_EXPORT_ERROR_NOTIMPL
        DFTTS_EXPORT_ERROR_ABORT
        DFTTS_EXPORT_ERROR_UNKNOWN
        DFTTS_EXPORT_ERROR_BADHANDLE
        DFTTS_EXPORT_ERROR_EXCEPTION
        DFTTS_EXPORT_ERROR_EMPTY
        DFTTS_EXPORT_ERROR_FULL
        DFTTS_EXPORT_ERROR_INVALIDSTATE
        DFTTS_EXPORT_ERROR_BADVERSION
        DFTTS_EXPORT_ERROR_INSUFFICIENT_BUFFER
        DFTTS_EXPORT_ERROR_UNSUPPORTED
        DFTTS_EXPORT_ERROR_NOLICENSE
        DFTTS_EXPORT_ERROR_CREATECHILDPROCESS_FAILED
        DFTTS_EXPORT_ERROR_NOENVIRONMENTPATH
        DFTTS_EXPORT_ERROR_TIMEOUT
        DFTTS_EXPORT_ERROR_OUTOFRESOURCES
        DFTTS_EXPORT_ERROR_NOVOICES
        DFTTS_EXPORT_ERROR_CREATEFAIL
        DFTTS_EXPORT_ERROR_CONNECTFAIL
        DFTTS_EXPORT_ERROR_BINDFAIL
        DFTTS_EXPORT_ERROR_LISTENFAIL
        DFTTS_EXPORT_ERROR_CONNECTIONCLOSED
        DFTTS_EXPORT_ERROR_ACCEPTFAIL
        DFTTS_EXPORT_ERROR_SOCKETTIMEOUT
        DFTTS_EXPORT_ERROR_SOCKETERROR
        DFTTS_EXPORT_ERROR_NOMORESERVERS
        DFTTS_EXPORT_ERROR_SOCKET_EWOULDBLOCK
        DFTTS_EXPORT_ERROR_SOCKET_EINPROGRESS
        DFTTS_EXPORT_ERROR_SOCKET_EALREADY
        DFTTS_EXPORT_ERROR_SOCKET_ENOTSOCK
        DFTTS_EXPORT_ERROR_SOCKET_EDESTADDRREQ
        DFTTS_EXPORT_ERROR_SOCKET_EMSGSIZE
        DFTTS_EXPORT_ERROR_SOCKET_EPROTOTYPE
        DFTTS_EXPORT_ERROR_SOCKET_ENOPROTOOPT
        DFTTS_EXPORT_ERROR_SOCKET_EPROTONOSUPPORT
        DFTTS_EXPORT_ERROR_SOCKET_ESOCKTNOSUPPORT
        DFTTS_EXPORT_ERROR_SOCKET_EOPNOTSUPP
        DFTTS_EXPORT_ERROR_SOCKET_EPFNOSUPPORT
        DFTTS_EXPORT_ERROR_SOCKET_EAFNOSUPPORT
        DFTTS_EXPORT_ERROR_SOCKET_EADDRINUSE
        DFTTS_EXPORT_ERROR_SOCKET_EADDRNOTAVAIL
        DFTTS_EXPORT_ERROR_SOCKET_ENETDOWN
        DFTTS_EXPORT_ERROR_SOCKET_ENETUNREACH
        DFTTS_EXPORT_ERROR_SOCKET_ENETRESET
        DFTTS_EXPORT_ERROR_SOCKET_ECONNABORTED
        DFTTS_EXPORT_ERROR_SOCKET_ECONNRESET
        DFTTS_EXPORT_ERROR_SOCKET_ENOBUFS
        DFTTS_EXPORT_ERROR_SOCKET_EISCONN
        DFTTS_EXPORT_ERROR_SOCKET_ENOTCONN
        DFTTS_EXPORT_ERROR_SOCKET_ESHUTDOWN
        DFTTS_EXPORT_ERROR_SOCKET_ETOOMANYREFS
        DFTTS_EXPORT_ERROR_SOCKET_ECONNREFUSED
        DFTTS_EXPORT_ERROR_SOCKET_ELOOP
        DFTTS_EXPORT_ERROR_SOCKET_ENAMETOOLONG
        DFTTS_EXPORT_ERROR_SOCKET_EHOSTDOWN
        DFTTS_EXPORT_ERROR_SOCKET_EHOSTUNREACH
        DFTTS_EXPORT_ERROR_SOCKET_ENOTEMPTY
        DFTTS_EXPORT_ERROR_SOCKET_EPROCLIM
        DFTTS_EXPORT_ERROR_THREADSTARTED
        DFTTS_EXPORT_ERROR_THREADNOTSTARTED
        DFTTS_EXPORT_ERROR_THREADCOULDNOTCREATE
        DFTTS_EXPORT_ERROR_BADNVFILE
        DFTTS_EXPORT_ERROR_NOAUDIODRIVER
        DFTTS_EXPORT_ERROR_DICTNOTFOUND
        DFTTS_EXPORT_ERROR_ALREADYPLAYING
        DFTTS_EXPORT_ERROR_AUDIOFORMATNOTSUPPORTED
        DFTTS_EXPORT_ERROR_XML_INVALID
        DFTTS_EXPORT_ERROR_WL_INVALID
        DFTTS_EXPORT_ERROR_INVALIDPHONESET
        DFTTS_EXPORT_ERROR_INVALIDPHONEME
        DFTTS_EXPORT_ERROR_MSGQ_CREATEFAILED
        DFTTS_EXPORT_ERROR_MSGQ_ALREADYEXISTS
        DFTTS_EXPORT_ERROR_MSGQ_NOTFOUND
        DFTTS_EXPORT_ERROR_MSGQ_INVALIDOP
        DFTTS_EXPORT_ERROR_MSGQ_NOTOPEN
        DFTTS_EXPORT_ERROR_MSGQ_LOCKFAILED
        DFTTS_EXPORT_ERROR_MSGQ_ABANDONED
        DFTTS_EXPORT_ERROR_MSGQ_OPENFAILED
        DFTTS_EXPORT_ERROR_OTHER

    End Enum

    Public Enum DFTTSVoiceInfoReturnValue

        GET_DFTTS_VI_SUCCESS
        GET_DFTTS_VI_NO_MORE_ITEMS
        GET_DFTTS_VI_ERROR_BUFFER_TOO_SMALL
        GET_DFTTS_VI_ERROR_OTHER

    End Enum

    '
    '  Language IDs.
    '
    '  The following two combinations of primary language ID and
    '  sublanguage ID have special semantics:
    '
    '    Primary Language ID   Sublanguage ID      Result
    '    -------------------   ---------------     ------------------------
    '    LANG_NEUTRAL          SUBLANG_NEUTRAL     Language neutral
    '    LANG_NEUTRAL          SUBLANG_DEFAULT     User default language
    '    LANG_NEUTRAL          SUBLANG_SYS_DEFAULT System default language
    '    LANG_INVARIANT        SUBLANG_NEUTRAL     Invariant locale
    '

    '
    '  Primary language IDs.
    '

    Public Const LANG_NEUTRAL As Integer = &H0
    Public Const LANG_INVARIANT As Integer = &H7F

    Public Const LANG_AFRIKAANS As Integer = &H36
    Public Const LANG_ALBANIAN As Integer = &H1C
    Public Const LANG_ALSATIAN As Integer = &H84
    Public Const LANG_AMHARIC As Integer = &H5E
    Public Const LANG_ARABIC As Integer = &H1
    Public Const LANG_ARMENIAN As Integer = &H2B
    Public Const LANG_ASSAMESE As Integer = &H4D
    Public Const LANG_AZERI As Integer = &H2C
    Public Const LANG_BASHKIR As Integer = &H6D
    Public Const LANG_BASQUE As Integer = &H2D
    Public Const LANG_BELARUSIAN As Integer = &H23
    Public Const LANG_BENGALI As Integer = &H45
    Public Const LANG_BRETON As Integer = &H7E
    Public Const LANG_BOSNIAN As Integer = &H1A                       ' Use with SUBLANG_BOSNIAN_* Sublanguage IDs
    Public Const LANG_BOSNIAN_NEUTRAL As Integer = &H781A             ' Use with the ConvertDefaultLocale function
    Public Const LANG_BULGARIAN As Integer = &H2
    Public Const LANG_CATALAN As Integer = &H3
    Public Const LANG_CHINESE As Integer = &H4                        ' Use with SUBLANG_CHINESE_* Sublanguage IDs
    Public Const LANG_CHINESE_SIMPLIFIED As Integer = &H4             ' Use with the ConvertDefaultLocale function
    Public Const LANG_CHINESE_TRADITIONAL As Integer = &H7C04         ' Use with the ConvertDefaultLocale function
    Public Const LANG_CORSICAN As Integer = &H83
    Public Const LANG_CROATIAN As Integer = &H1A
    Public Const LANG_CZECH As Integer = &H5
    Public Const LANG_DANISH As Integer = &H6
    Public Const LANG_DARI As Integer = &H8C
    Public Const LANG_DIVEHI As Integer = &H65
    Public Const LANG_DUTCH As Integer = &H13
    Public Const LANG_ENGLISH As Integer = &H9
    Public Const LANG_ESTONIAN As Integer = &H25
    Public Const LANG_FAEROESE As Integer = &H38
    Public Const LANG_FARSI As Integer = &H29                         ' Deprecated: use LANG_PERSIAN instead
    Public Const LANG_FILIPINO As Integer = &H64
    Public Const LANG_FINNISH As Integer = &HB
    Public Const LANG_FRENCH As Integer = &HC
    Public Const LANG_FRISIAN As Integer = &H62
    Public Const LANG_GALICIAN As Integer = &H56
    Public Const LANG_GEORGIAN As Integer = &H37
    Public Const LANG_GERMAN As Integer = &H7
    Public Const LANG_GREEK As Integer = &H8
    Public Const LANG_GREENLANDIC As Integer = &H6F
    Public Const LANG_GUJARATI As Integer = &H47
    Public Const LANG_HAUSA As Integer = &H68
    Public Const LANG_HEBREW As Integer = &HD
    Public Const LANG_HINDI As Integer = &H39
    Public Const LANG_HUNGARIAN As Integer = &HE
    Public Const LANG_ICELANDIC As Integer = &HF
    Public Const LANG_IGBO As Integer = &H70
    Public Const LANG_INDONESIAN As Integer = &H21
    Public Const LANG_INUKTITUT As Integer = &H5D
    Public Const LANG_IRISH As Integer = &H3C                         ' Use with the SUBLANG_IRISH_IRELAND Sublanguage ID
    Public Const LANG_ITALIAN As Integer = &H10
    Public Const LANG_JAPANESE As Integer = &H11
    Public Const LANG_KANNADA As Integer = &H4B
    Public Const LANG_KASHMIRI As Integer = &H60
    Public Const LANG_KAZAK As Integer = &H3F
    Public Const LANG_KHMER As Integer = &H53
    Public Const LANG_KICHE As Integer = &H86
    Public Const LANG_KINYARWANDA As Integer = &H87
    Public Const LANG_KONKANI As Integer = &H57
    Public Const LANG_KOREAN As Integer = &H12
    Public Const LANG_KYRGYZ As Integer = &H40
    Public Const LANG_LAO As Integer = &H54
    Public Const LANG_LATVIAN As Integer = &H26
    Public Const LANG_LITHUANIAN As Integer = &H27
    Public Const LANG_LOWER_SORBIAN As Integer = &H2E
    Public Const LANG_LUXEMBOURGISH As Integer = &H6E
    Public Const LANG_MACEDONIAN As Integer = &H2F                    ' the Former Yugoslav Republic of Macedonia
    Public Const LANG_MALAY As Integer = &H3E
    Public Const LANG_MALAYALAM As Integer = &H4C
    Public Const LANG_MALTESE As Integer = &H3A
    Public Const LANG_MANIPURI As Integer = &H58
    Public Const LANG_MAORI As Integer = &H81
    Public Const LANG_MAPUDUNGUN As Integer = &H7A
    Public Const LANG_MARATHI As Integer = &H4E
    Public Const LANG_MOHAWK As Integer = &H7C
    Public Const LANG_MONGOLIAN As Integer = &H50
    Public Const LANG_NEPALI As Integer = &H61
    Public Const LANG_NORWEGIAN As Integer = &H14
    Public Const LANG_OCCITAN As Integer = &H82
    Public Const LANG_ORIYA As Integer = &H48
    Public Const LANG_PASHTO As Integer = &H63
    Public Const LANG_PERSIAN As Integer = &H29
    Public Const LANG_POLISH As Integer = &H15
    Public Const LANG_PORTUGUESE As Integer = &H16
    Public Const LANG_PUNJABI As Integer = &H46
    Public Const LANG_QUECHUA As Integer = &H6B
    Public Const LANG_ROMANIAN As Integer = &H18
    Public Const LANG_ROMANSH As Integer = &H17
    Public Const LANG_RUSSIAN As Integer = &H19
    Public Const LANG_SAMI As Integer = &H3B
    Public Const LANG_SANSKRIT As Integer = &H4F
    Public Const LANG_SERBIAN As Integer = &H1A                       ' Use with the SUBLANG_SERBIAN_* Sublanguage IDs
    Public Const LANG_SERBIAN_NEUTRAL As Integer = &H7C1A             ' Use with the ConvertDefaultLocale function
    Public Const LANG_SINDHI As Integer = &H59
    Public Const LANG_SINHALESE As Integer = &H5B
    Public Const LANG_SLOVAK As Integer = &H1B
    Public Const LANG_SLOVENIAN As Integer = &H24
    Public Const LANG_SOTHO As Integer = &H6C
    Public Const LANG_SPANISH As Integer = &HA
    Public Const LANG_SWAHILI As Integer = &H41
    Public Const LANG_SWEDISH As Integer = &H1D
    Public Const LANG_SYRIAC As Integer = &H5A
    Public Const LANG_TAJIK As Integer = &H28
    Public Const LANG_TAMAZIGHT As Integer = &H5F
    Public Const LANG_TAMIL As Integer = &H49
    Public Const LANG_TATAR As Integer = &H44
    Public Const LANG_TELUGU As Integer = &H4A
    Public Const LANG_THAI As Integer = &H1E
    Public Const LANG_TIBETAN As Integer = &H51
    Public Const LANG_TIGRIGNA As Integer = &H73
    Public Const LANG_TSWANA As Integer = &H32
    Public Const LANG_TURKISH As Integer = &H1F
    Public Const LANG_TURKMEN As Integer = &H42
    Public Const LANG_UIGHUR As Integer = &H80
    Public Const LANG_UKRAINIAN As Integer = &H22
    Public Const LANG_UPPER_SORBIAN As Integer = &H2E
    Public Const LANG_URDU As Integer = &H20
    Public Const LANG_UZBEK As Integer = &H43
    Public Const LANG_VIETNAMESE As Integer = &H2A
    Public Const LANG_WELSH As Integer = &H52
    Public Const LANG_WOLOF As Integer = &H88
    Public Const LANG_XHOSA As Integer = &H34
    Public Const LANG_YAKUT As Integer = &H85
    Public Const LANG_YI As Integer = &H78
    Public Const LANG_YORUBA As Integer = &H6A
    Public Const LANG_ZULU As Integer = &H35

    '
    '  Sublanguage IDs.
    '
    '  The name immediately following SUBLANG_ dictates which primary
    '  language ID that sublanguage ID can be combined with to form a
    '  valid language ID.
    '

    Public Const SUBLANG_NEUTRAL As Integer = &H0                                 ' language neutral
    Public Const SUBLANG_DEFAULT As Integer = &H1                                 ' user default
    Public Const SUBLANG_SYS_DEFAULT As Integer = &H2                             ' system default
    Public Const SUBLANG_CUSTOM_DEFAULT As Integer = &H3                          ' default custom language/locale
    Public Const SUBLANG_CUSTOM_UNSPECIFIED As Integer = &H4                      ' custom language/locale
    Public Const SUBLANG_UI_CUSTOM_DEFAULT As Integer = &H5                       ' Default custom MUI language/locale


    Public Const SUBLANG_AFRIKAANS_SOUTH_AFRICA As Integer = &H1                  ' Afrikaans (South Africa) As Integer = &H0436 af-ZA
    Public Const SUBLANG_ALBANIAN_ALBANIA As Integer = &H1                        ' Albanian (Albania) As Integer = &H041c sq-AL
    Public Const SUBLANG_ALSATIAN_FRANCE As Integer = &H1                         ' Alsatian (France) As Integer = &H0484
    Public Const SUBLANG_AMHARIC_ETHIOPIA As Integer = &H1                        ' Amharic (Ethiopia) As Integer = &H045e
    Public Const SUBLANG_ARABIC_SAUDI_ARABIA As Integer = &H1                     ' Arabic (Saudi Arabia)
    Public Const SUBLANG_ARABIC_IRAQ As Integer = &H2                             ' Arabic (Iraq)
    Public Const SUBLANG_ARABIC_EGYPT As Integer = &H3                            ' Arabic (Egypt)
    Public Const SUBLANG_ARABIC_LIBYA As Integer = &H4                            ' Arabic (Libya)
    Public Const SUBLANG_ARABIC_ALGERIA As Integer = &H5                          ' Arabic (Algeria)
    Public Const SUBLANG_ARABIC_MOROCCO As Integer = &H6                          ' Arabic (Morocco)
    Public Const SUBLANG_ARABIC_TUNISIA As Integer = &H7                          ' Arabic (Tunisia)
    Public Const SUBLANG_ARABIC_OMAN As Integer = &H8                             ' Arabic (Oman)
    Public Const SUBLANG_ARABIC_YEMEN As Integer = &H9                            ' Arabic (Yemen)
    Public Const SUBLANG_ARABIC_SYRIA As Integer = &HA                            ' Arabic (Syria)
    Public Const SUBLANG_ARABIC_JORDAN As Integer = &HB                           ' Arabic (Jordan)
    Public Const SUBLANG_ARABIC_LEBANON As Integer = &HC                          ' Arabic (Lebanon)
    Public Const SUBLANG_ARABIC_KUWAIT As Integer = &HD                           ' Arabic (Kuwait)
    Public Const SUBLANG_ARABIC_UAE As Integer = &HE                              ' Arabic (U.A.E)
    Public Const SUBLANG_ARABIC_BAHRAIN As Integer = &HF                          ' Arabic (Bahrain)
    Public Const SUBLANG_ARABIC_QATAR As Integer = &H10                           ' Arabic (Qatar)
    Public Const SUBLANG_ARMENIAN_ARMENIA As Integer = &H1                        ' Armenian (Armenia) As Integer = &H042b hy-AM
    Public Const SUBLANG_ASSAMESE_INDIA As Integer = &H1                          ' Assamese (India) As Integer = &H044d
    Public Const SUBLANG_AZERI_LATIN As Integer = &H1                             ' Azeri (Latin)
    Public Const SUBLANG_AZERI_CYRILLIC As Integer = &H2                          ' Azeri (Cyrillic)
    Public Const SUBLANG_BASHKIR_RUSSIA As Integer = &H1                          ' Bashkir (Russia) As Integer = &H046d ba-RU
    Public Const SUBLANG_BASQUE_BASQUE As Integer = &H1                           ' Basque (Basque) As Integer = &H042d eu-ES
    Public Const SUBLANG_BELARUSIAN_BELARUS As Integer = &H1                      ' Belarusian (Belarus) As Integer = &H0423 be-BY
    Public Const SUBLANG_BENGALI_INDIA As Integer = &H1                           ' Bengali (India)
    Public Const SUBLANG_BENGALI_BANGLADESH As Integer = &H2                      ' Bengali (Bangladesh)
    Public Const SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN As Integer = &H5        ' Bosnian (Bosnia and Herzegovina - Latin) As Integer = &H141a bs-BA-Latn
    Public Const SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC As Integer = &H8     ' Bosnian (Bosnia and Herzegovina - Cyrillic) As Integer = &H201a bs-BA-Cyrl
    Public Const SUBLANG_BRETON_FRANCE As Integer = &H1                           ' Breton (France) As Integer = &H047e
    Public Const SUBLANG_BULGARIAN_BULGARIA As Integer = &H1                      ' Bulgarian (Bulgaria) As Integer = &H0402
    Public Const SUBLANG_CATALAN_CATALAN As Integer = &H1                         ' Catalan (Catalan) As Integer = &H0403
    Public Const SUBLANG_CHINESE_TRADITIONAL As Integer = &H1                     ' Chinese (Taiwan) As Integer = &H0404 zh-TW
    Public Const SUBLANG_CHINESE_SIMPLIFIED As Integer = &H2                      ' Chinese (PR China) As Integer = &H0804 zh-CN
    Public Const SUBLANG_CHINESE_HONGKONG As Integer = &H3                        ' Chinese (Hong Kong S.A.R., P.R.C.) As Integer = &H0c04 zh-HK
    Public Const SUBLANG_CHINESE_SINGAPORE As Integer = &H4                       ' Chinese (Singapore) As Integer = &H1004 zh-SG
    Public Const SUBLANG_CHINESE_MACAU As Integer = &H5                           ' Chinese (Macau S.A.R.) As Integer = &H1404 zh-MO
    Public Const SUBLANG_CORSICAN_FRANCE As Integer = &H1                         ' Corsican (France) As Integer = &H0483
    Public Const SUBLANG_CZECH_CZECH_REPUBLIC As Integer = &H1                    ' Czech (Czech Republic) As Integer = &H0405
    Public Const SUBLANG_CROATIAN_CROATIA As Integer = &H1                        ' Croatian (Croatia)
    Public Const SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN As Integer = &H4       ' Croatian (Bosnia and Herzegovina - Latin) As Integer = &H101a hr-BA
    Public Const SUBLANG_DANISH_DENMARK As Integer = &H1                          ' Danish (Denmark) As Integer = &H0406
    Public Const SUBLANG_DARI_AFGHANISTAN As Integer = &H1                        ' Dari (Afghanistan)
    Public Const SUBLANG_DIVEHI_MALDIVES As Integer = &H1                         ' Divehi (Maldives) As Integer = &H0465 div-MV
    Public Const SUBLANG_DUTCH As Integer = &H1                                   ' Dutch
    Public Const SUBLANG_DUTCH_BELGIAN As Integer = &H2                           ' Dutch (Belgian)
    Public Const SUBLANG_ENGLISH_US As Integer = &H1                              ' English (USA)
    Public Const SUBLANG_ENGLISH_UK As Integer = &H2                              ' English (UK)
    Public Const SUBLANG_ENGLISH_AUS As Integer = &H3                             ' English (Australian)
    Public Const SUBLANG_ENGLISH_CAN As Integer = &H4                             ' English (Canadian)
    Public Const SUBLANG_ENGLISH_NZ As Integer = &H5                              ' English (New Zealand)
    Public Const SUBLANG_ENGLISH_EIRE As Integer = &H6                            ' English (Irish)
    Public Const SUBLANG_ENGLISH_SOUTH_AFRICA As Integer = &H7                    ' English (South Africa)
    Public Const SUBLANG_ENGLISH_JAMAICA As Integer = &H8                         ' English (Jamaica)
    Public Const SUBLANG_ENGLISH_CARIBBEAN As Integer = &H9                       ' English (Caribbean)
    Public Const SUBLANG_ENGLISH_BELIZE As Integer = &HA                          ' English (Belize)
    Public Const SUBLANG_ENGLISH_TRINIDAD As Integer = &HB                        ' English (Trinidad)
    Public Const SUBLANG_ENGLISH_ZIMBABWE As Integer = &HC                        ' English (Zimbabwe)
    Public Const SUBLANG_ENGLISH_PHILIPPINES As Integer = &HD                     ' English (Philippines)
    Public Const SUBLANG_ENGLISH_INDIA As Integer = &H10                          ' English (India)
    Public Const SUBLANG_ENGLISH_MALAYSIA As Integer = &H11                       ' English (Malaysia)
    Public Const SUBLANG_ENGLISH_SINGAPORE As Integer = &H12                      ' English (Singapore)
    Public Const SUBLANG_ESTONIAN_ESTONIA As Integer = &H1                        ' Estonian (Estonia) As Integer = &H0425 et-EE
    Public Const SUBLANG_FAEROESE_FAROE_ISLANDS As Integer = &H1                  ' Faroese (Faroe Islands) As Integer = &H0438 fo-FO
    Public Const SUBLANG_FILIPINO_PHILIPPINES As Integer = &H1                    ' Filipino (Philippines) As Integer = &H0464 fil-PH
    Public Const SUBLANG_FINNISH_FINLAND As Integer = &H1                         ' Finnish (Finland) As Integer = &H040b
    Public Const SUBLANG_FRENCH As Integer = &H1                                  ' French
    Public Const SUBLANG_FRENCH_BELGIAN As Integer = &H2                          ' French (Belgian)
    Public Const SUBLANG_FRENCH_CANADIAN As Integer = &H3                         ' French (Canadian)
    Public Const SUBLANG_FRENCH_SWISS As Integer = &H4                            ' French (Swiss)
    Public Const SUBLANG_FRENCH_LUXEMBOURG As Integer = &H5                       ' French (Luxembourg)
    Public Const SUBLANG_FRENCH_MONACO As Integer = &H6                           ' French (Monaco)
    Public Const SUBLANG_FRISIAN_NETHERLANDS As Integer = &H1                     ' Frisian (Netherlands) As Integer = &H0462 fy-NL
    Public Const SUBLANG_GALICIAN_GALICIAN As Integer = &H1                       ' Galician (Galician) As Integer = &H0456 gl-ES
    Public Const SUBLANG_GEORGIAN_GEORGIA As Integer = &H1                        ' Georgian (Georgia) As Integer = &H0437 ka-GE
    Public Const SUBLANG_GERMAN As Integer = &H1                                  ' German
    Public Const SUBLANG_GERMAN_SWISS As Integer = &H2                            ' German (Swiss)
    Public Const SUBLANG_GERMAN_AUSTRIAN As Integer = &H3                         ' German (Austrian)
    Public Const SUBLANG_GERMAN_LUXEMBOURG As Integer = &H4                       ' German (Luxembourg)
    Public Const SUBLANG_GERMAN_LIECHTENSTEIN As Integer = &H5                    ' German (Liechtenstein)
    Public Const SUBLANG_GREEK_GREECE As Integer = &H1                            ' Greek (Greece)
    Public Const SUBLANG_GREENLANDIC_GREENLAND As Integer = &H1                   ' Greenlandic (Greenland) As Integer = &H046f kl-GL
    Public Const SUBLANG_GUJARATI_INDIA As Integer = &H1                          ' Gujarati (India (Gujarati Script)) As Integer = &H0447 gu-IN
    Public Const SUBLANG_HAUSA_NIGERIA_LATIN As Integer = &H1                     ' Hausa (Latin, Nigeria) As Integer = &H0468 ha-NG-Latn
    Public Const SUBLANG_HEBREW_ISRAEL As Integer = &H1                           ' Hebrew (Israel) As Integer = &H040d
    Public Const SUBLANG_HINDI_INDIA As Integer = &H1                             ' Hindi (India) As Integer = &H0439 hi-IN
    Public Const SUBLANG_HUNGARIAN_HUNGARY As Integer = &H1                       ' Hungarian (Hungary) As Integer = &H040e
    Public Const SUBLANG_ICELANDIC_ICELAND As Integer = &H1                       ' Icelandic (Iceland) As Integer = &H040f
    Public Const SUBLANG_IGBO_NIGERIA As Integer = &H1                            ' Igbo (Nigeria) As Integer = &H0470 ig-NG
    Public Const SUBLANG_INDONESIAN_INDONESIA As Integer = &H1                    ' Indonesian (Indonesia) As Integer = &H0421 id-ID
    Public Const SUBLANG_INUKTITUT_CANADA As Integer = &H1                        ' Inuktitut (Syllabics) (Canada) As Integer = &H045d iu-CA-Cans
    Public Const SUBLANG_INUKTITUT_CANADA_LATIN As Integer = &H2                  ' Inuktitut (Canada - Latin)
    Public Const SUBLANG_IRISH_IRELAND As Integer = &H2                           ' Irish (Ireland)
    Public Const SUBLANG_ITALIAN As Integer = &H1                                 ' Italian
    Public Const SUBLANG_ITALIAN_SWISS As Integer = &H2                           ' Italian (Swiss)
    Public Const SUBLANG_JAPANESE_JAPAN As Integer = &H1                          ' Japanese (Japan) As Integer = &H0411
    Public Const SUBLANG_KANNADA_INDIA As Integer = &H1                           ' Kannada (India (Kannada Script)) As Integer = &H044b kn-IN
    Public Const SUBLANG_KASHMIRI_SASIA As Integer = &H2                          ' Kashmiri (South Asia)
    Public Const SUBLANG_KASHMIRI_INDIA As Integer = &H2                          ' For app compatibility only
    Public Const SUBLANG_KAZAK_KAZAKHSTAN As Integer = &H1                        ' Kazakh (Kazakhstan) As Integer = &H043f kk-KZ
    Public Const SUBLANG_KHMER_CAMBODIA As Integer = &H1                          ' Khmer (Cambodia) As Integer = &H0453 kh-KH
    Public Const SUBLANG_KICHE_GUATEMALA As Integer = &H1                         ' K'iche (Guatemala)
    Public Const SUBLANG_KINYARWANDA_RWANDA As Integer = &H1                      ' Kinyarwanda (Rwanda) As Integer = &H0487 rw-RW
    Public Const SUBLANG_KONKANI_INDIA As Integer = &H1                           ' Konkani (India) As Integer = &H0457 kok-IN
    Public Const SUBLANG_KOREAN As Integer = &H1                                  ' Korean (Extended Wansung)
    Public Const SUBLANG_KYRGYZ_KYRGYZSTAN As Integer = &H1                       ' Kyrgyz (Kyrgyzstan) As Integer = &H0440 ky-KG
    Public Const SUBLANG_LAO_LAO As Integer = &H1                                 ' Lao (Lao PDR) As Integer = &H0454 lo-LA
    Public Const SUBLANG_LATVIAN_LATVIA As Integer = &H1                          ' Latvian (Latvia) As Integer = &H0426 lv-LV
    Public Const SUBLANG_LITHUANIAN As Integer = &H1                              ' Lithuanian
    Public Const SUBLANG_LOWER_SORBIAN_GERMANY As Integer = &H2                   ' Lower Sorbian (Germany) As Integer = &H082e wee-DE
    Public Const SUBLANG_LUXEMBOURGISH_LUXEMBOURG As Integer = &H1                ' Luxembourgish (Luxembourg) As Integer = &H046e lb-LU
    Public Const SUBLANG_MACEDONIAN_MACEDONIA As Integer = &H1                    ' Macedonian (Macedonia (FYROM)) As Integer = &H042f mk-MK
    Public Const SUBLANG_MALAY_MALAYSIA As Integer = &H1                          ' Malay (Malaysia)
    Public Const SUBLANG_MALAY_BRUNEI_DARUSSALAM As Integer = &H2                 ' Malay (Brunei Darussalam)
    Public Const SUBLANG_MALAYALAM_INDIA As Integer = &H1                         ' Malayalam (India (Malayalam Script) ) As Integer = &H044c ml-IN
    Public Const SUBLANG_MALTESE_MALTA As Integer = &H1                           ' Maltese (Malta) As Integer = &H043a mt-MT
    Public Const SUBLANG_MAORI_NEW_ZEALAND As Integer = &H1                       ' Maori (New Zealand) As Integer = &H0481 mi-NZ
    Public Const SUBLANG_MAPUDUNGUN_CHILE As Integer = &H1                        ' Mapudungun (Chile) As Integer = &H047a arn-CL
    Public Const SUBLANG_MARATHI_INDIA As Integer = &H1                           ' Marathi (India) As Integer = &H044e mr-IN
    Public Const SUBLANG_MOHAWK_MOHAWK As Integer = &H1                           ' Mohawk (Mohawk) As Integer = &H047c moh-CA
    Public Const SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA As Integer = &H1             ' Mongolian (Cyrillic, Mongolia)
    Public Const SUBLANG_MONGOLIAN_PRC As Integer = &H2                           ' Mongolian (PRC)
    Public Const SUBLANG_NEPALI_INDIA As Integer = &H2                            ' Nepali (India)
    Public Const SUBLANG_NEPALI_NEPAL As Integer = &H1                            ' Nepali (Nepal) As Integer = &H0461 ne-NP
    Public Const SUBLANG_NORWEGIAN_BOKMAL As Integer = &H1                        ' Norwegian (Bokmal)
    Public Const SUBLANG_NORWEGIAN_NYNORSK As Integer = &H2                       ' Norwegian (Nynorsk)
    Public Const SUBLANG_OCCITAN_FRANCE As Integer = &H1                          ' Occitan (France) As Integer = &H0482 oc-FR
    Public Const SUBLANG_ORIYA_INDIA As Integer = &H1                             ' Oriya (India (Oriya Script)) As Integer = &H0448 or-IN
    Public Const SUBLANG_PASHTO_AFGHANISTAN As Integer = &H1                      ' Pashto (Afghanistan)
    Public Const SUBLANG_PERSIAN_IRAN As Integer = &H1                            ' Persian (Iran) As Integer = &H0429 fa-IR
    Public Const SUBLANG_POLISH_POLAND As Integer = &H1                           ' Polish (Poland) As Integer = &H0415
    Public Const SUBLANG_PORTUGUESE As Integer = &H2                              ' Portuguese
    Public Const SUBLANG_PORTUGUESE_BRAZILIAN As Integer = &H1                    ' Portuguese (Brazilian)
    Public Const SUBLANG_PUNJABI_INDIA As Integer = &H1                           ' Punjabi (India (Gurmukhi Script)) As Integer = &H0446 pa-IN
    Public Const SUBLANG_QUECHUA_BOLIVIA As Integer = &H1                         ' Quechua (Bolivia)
    Public Const SUBLANG_QUECHUA_ECUADOR As Integer = &H2                         ' Quechua (Ecuador)
    Public Const SUBLANG_QUECHUA_PERU As Integer = &H3                            ' Quechua (Peru)
    Public Const SUBLANG_ROMANIAN_ROMANIA As Integer = &H1                        ' Romanian (Romania) As Integer = &H0418
    Public Const SUBLANG_ROMANSH_SWITZERLAND As Integer = &H1                     ' Romansh (Switzerland) As Integer = &H0417 rm-CH
    Public Const SUBLANG_RUSSIAN_RUSSIA As Integer = &H1                          ' Russian (Russia) As Integer = &H0419
    Public Const SUBLANG_SAMI_NORTHERN_NORWAY As Integer = &H1                    ' Northern Sami (Norway)
    Public Const SUBLANG_SAMI_NORTHERN_SWEDEN As Integer = &H2                    ' Northern Sami (Sweden)
    Public Const SUBLANG_SAMI_NORTHERN_FINLAND As Integer = &H3                   ' Northern Sami (Finland)
    Public Const SUBLANG_SAMI_LULE_NORWAY As Integer = &H4                        ' Lule Sami (Norway)
    Public Const SUBLANG_SAMI_LULE_SWEDEN As Integer = &H5                        ' Lule Sami (Sweden)
    Public Const SUBLANG_SAMI_SOUTHERN_NORWAY As Integer = &H6                    ' Southern Sami (Norway)
    Public Const SUBLANG_SAMI_SOUTHERN_SWEDEN As Integer = &H7                    ' Southern Sami (Sweden)
    Public Const SUBLANG_SAMI_SKOLT_FINLAND As Integer = &H8                      ' Skolt Sami (Finland)
    Public Const SUBLANG_SAMI_INARI_FINLAND As Integer = &H9                      ' Inari Sami (Finland)
    Public Const SUBLANG_SANSKRIT_INDIA As Integer = &H1                          ' Sanskrit (India) As Integer = &H044f sa-IN
    Public Const SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN As Integer = &H6        ' Serbian (Bosnia and Herzegovina - Latin)
    Public Const SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC As Integer = &H7     ' Serbian (Bosnia and Herzegovina - Cyrillic)
    Public Const SUBLANG_SERBIAN_CROATIA As Integer = &H1                         ' Croatian (Croatia) As Integer = &H041a hr-HR
    Public Const SUBLANG_SERBIAN_LATIN As Integer = &H2                           ' Serbian (Latin)
    Public Const SUBLANG_SERBIAN_CYRILLIC As Integer = &H3                        ' Serbian (Cyrillic)
    Public Const SUBLANG_SINDHI_INDIA As Integer = &H1                            ' Sindhi (India) reserved As Integer = &H0459
    Public Const SUBLANG_SINDHI_PAKISTAN As Integer = &H2                         ' Sindhi (Pakistan) reserved As Integer = &H0859
    Public Const SUBLANG_SINDHI_AFGHANISTAN As Integer = &H2                      ' For app compatibility only
    Public Const SUBLANG_SINHALESE_SRI_LANKA As Integer = &H1                     ' Sinhalese (Sri Lanka)
    Public Const SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA As Integer = &H1             ' Northern Sotho (South Africa)
    Public Const SUBLANG_SLOVAK_SLOVAKIA As Integer = &H1                         ' Slovak (Slovakia) As Integer = &H041b sk-SK
    Public Const SUBLANG_SLOVENIAN_SLOVENIA As Integer = &H1                      ' Slovenian (Slovenia) As Integer = &H0424 sl-SI
    Public Const SUBLANG_SPANISH As Integer = &H1                                 ' Spanish (Castilian)
    Public Const SUBLANG_SPANISH_MEXICAN As Integer = &H2                         ' Spanish (Mexican)
    Public Const SUBLANG_SPANISH_MODERN As Integer = &H3                          ' Spanish (Modern)
    Public Const SUBLANG_SPANISH_GUATEMALA As Integer = &H4                       ' Spanish (Guatemala)
    Public Const SUBLANG_SPANISH_COSTA_RICA As Integer = &H5                      ' Spanish (Costa Rica)
    Public Const SUBLANG_SPANISH_PANAMA As Integer = &H6                          ' Spanish (Panama)
    Public Const SUBLANG_SPANISH_DOMINICAN_REPUBLIC As Integer = &H7              ' Spanish (Dominican Republic)
    Public Const SUBLANG_SPANISH_VENEZUELA As Integer = &H8                       ' Spanish (Venezuela)
    Public Const SUBLANG_SPANISH_COLOMBIA As Integer = &H9                        ' Spanish (Colombia)
    Public Const SUBLANG_SPANISH_PERU As Integer = &HA                            ' Spanish (Peru)
    Public Const SUBLANG_SPANISH_ARGENTINA As Integer = &HB                       ' Spanish (Argentina)
    Public Const SUBLANG_SPANISH_ECUADOR As Integer = &HC                         ' Spanish (Ecuador)
    Public Const SUBLANG_SPANISH_CHILE As Integer = &HD                           ' Spanish (Chile)
    Public Const SUBLANG_SPANISH_URUGUAY As Integer = &HE                         ' Spanish (Uruguay)
    Public Const SUBLANG_SPANISH_PARAGUAY As Integer = &HF                        ' Spanish (Paraguay)
    Public Const SUBLANG_SPANISH_BOLIVIA As Integer = &H10                        ' Spanish (Bolivia)
    Public Const SUBLANG_SPANISH_EL_SALVADOR As Integer = &H11                    ' Spanish (El Salvador)
    Public Const SUBLANG_SPANISH_HONDURAS As Integer = &H12                       ' Spanish (Honduras)
    Public Const SUBLANG_SPANISH_NICARAGUA As Integer = &H13                      ' Spanish (Nicaragua)
    Public Const SUBLANG_SPANISH_PUERTO_RICO As Integer = &H14                    ' Spanish (Puerto Rico)
    Public Const SUBLANG_SPANISH_US As Integer = &H15                             ' Spanish (United States)
    Public Const SUBLANG_SWAHILI_KENYA As Integer = &H1                           ' Swahili (Kenya) As Integer = &H0441 sw-KE
    Public Const SUBLANG_SWEDISH As Integer = &H1                                 ' Swedish
    Public Const SUBLANG_SWEDISH_FINLAND As Integer = &H2                         ' Swedish (Finland)
    Public Const SUBLANG_SYRIAC_SYRIA As Integer = &H1                            ' Syriac (Syria) As Integer = &H045a syr-SY
    Public Const SUBLANG_TAJIK_TAJIKISTAN As Integer = &H1                        ' Tajik (Tajikistan) As Integer = &H0428 tg-TJ-Cyrl
    Public Const SUBLANG_TAMAZIGHT_ALGERIA_LATIN As Integer = &H2                 ' Tamazight (Latin, Algeria) As Integer = &H085f tmz-DZ-Latn
    Public Const SUBLANG_TAMIL_INDIA As Integer = &H1                             ' Tamil (India)
    Public Const SUBLANG_TATAR_RUSSIA As Integer = &H1                            ' Tatar (Russia) As Integer = &H0444 tt-RU
    Public Const SUBLANG_TELUGU_INDIA As Integer = &H1                            ' Telugu (India (Telugu Script)) As Integer = &H044a te-IN
    Public Const SUBLANG_THAI_THAILAND As Integer = &H1                           ' Thai (Thailand) As Integer = &H041e th-TH
    Public Const SUBLANG_TIBETAN_PRC As Integer = &H1                             ' Tibetan (PRC)
    Public Const SUBLANG_TIGRIGNA_ERITREA As Integer = &H2                        ' Tigrigna (Eritrea)
    Public Const SUBLANG_TSWANA_SOUTH_AFRICA As Integer = &H1                     ' Setswana / Tswana (South Africa) As Integer = &H0432 tn-ZA
    Public Const SUBLANG_TURKISH_TURKEY As Integer = &H1                          ' Turkish (Turkey) As Integer = &H041f tr-TR
    Public Const SUBLANG_TURKMEN_TURKMENISTAN As Integer = &H1                    ' Turkmen (Turkmenistan) As Integer = &H0442 tk-TM
    Public Const SUBLANG_UIGHUR_PRC As Integer = &H1                              ' Uighur (PRC) As Integer = &H0480 ug-CN
    Public Const SUBLANG_UKRAINIAN_UKRAINE As Integer = &H1                       ' Ukrainian (Ukraine) As Integer = &H0422 uk-UA
    Public Const SUBLANG_UPPER_SORBIAN_GERMANY As Integer = &H1                   ' Upper Sorbian (Germany) As Integer = &H042e wen-DE
    Public Const SUBLANG_URDU_PAKISTAN As Integer = &H1                           ' Urdu (Pakistan)
    Public Const SUBLANG_URDU_INDIA As Integer = &H2                              ' Urdu (India)
    Public Const SUBLANG_UZBEK_LATIN As Integer = &H1                             ' Uzbek (Latin)
    Public Const SUBLANG_UZBEK_CYRILLIC As Integer = &H2                          ' Uzbek (Cyrillic)
    Public Const SUBLANG_VIETNAMESE_VIETNAM As Integer = &H1                      ' Vietnamese (Vietnam) As Integer = &H042a vi-VN
    Public Const SUBLANG_WELSH_UNITED_KINGDOM As Integer = &H1                    ' Welsh (United Kingdom) As Integer = &H0452 cy-GB
    Public Const SUBLANG_WOLOF_SENEGAL As Integer = &H1                           ' Wolof (Senegal)
    Public Const SUBLANG_XHOSA_SOUTH_AFRICA As Integer = &H1                      ' isiXhosa / Xhosa (South Africa) As Integer = &H0434 xh-ZA
    Public Const SUBLANG_YAKUT_RUSSIA As Integer = &H1                            ' Yakut (Russia) As Integer = &H0485 sah-RU
    Public Const SUBLANG_YI_PRC As Integer = &H1                                  ' Yi (PRC)) As Integer = &H0478
    Public Const SUBLANG_YORUBA_NIGERIA As Integer = &H1                          ' Yoruba (Nigeria) 046a yo-NG
    Public Const SUBLANG_ZULU_SOUTH_AFRICA As Integer = &H1                       ' isiZulu / Zulu (South Africa) As Integer = &H0435 zu-ZA


    '
    '  A language ID is a 16 bit value which is the combination of a
    '  primary language ID and a secondary language ID.  The bits are
    '  allocated as follows:
    '
    '       +-----------------------+-------------------------+
    '       |     Sublanguage ID    |   Primary Language ID   |
    '       +-----------------------+-------------------------+
    '        15                   10 9                       0   bit
    '


    'Neutral language

    Public Const LANG_SUBLANG_NEUTRAL As Integer = &H0


    Public Enum NeoSpeechVoiceTextAudioFormat

        VT_FILE_API_FMT_S16PCM = 0
        VT_FILE_API_FMT_ALAW = 1
        VT_FILE_API_FMT_MULAW = 2
        VT_FILE_API_FMT_DADPCM = 3
        VT_FILE_API_FMT_S16PCM_WAVE = 4
        VT_FILE_API_FMT_U08PCM_WAVE = 5
        VT_FILE_API_FMT_IMA_WAVE = 6
        VT_FILE_API_FMT_ALAW_WAVE = 7
        VT_FILE_API_FMT_MULAW_WAVE = 8
        VT_FILE_API_FMT_MULAW_AU = 9

    End Enum

    'Export formats for Cepstral voices

    'You need to set the following instead:

    'szAudioEncoding [possible values: 
    '   * "riff": Microsoft RIFF (WAV) file 
    '   * "pcm16", "pcm8" PCM 16 bit/8 bit WAV _
    '   * "ulaw" - -Law (8-bit by definition), "alaw" - A-Law (8-bit by definition) 
    '   * "snd": Sun/NeXT .au (SND) format. 
    '   * "raw": unheadered audio data, native byte order 
    '    * "le": unheadered audio data, little-endian (LSB first) 
    '    * "be": unheadered audio data, big-endian (MSB first) 
    '    * NOTE: that not all encoding types may be supported by all formats. For instance, SND doesn't support A-Law. ], _
    'iAudioSamplingRate [possible values: 8000 (8 KHz), 16000 (16 KHz), 11025 (11.025 kHz), etc ], _
    'iAudioChannels [possible values: 1 (mono), 2 (stereo)]

    'Export formats for AT&T NV (INTERNAL USE ONLY) _
    'Currently only PCM WAV supported  (all audio format arguments will be ignored)




    Public Enum NeoSpeechVoiceID

        NEOSPEECH_KATE_ENG = 0

        NEOSPEECH_PAUL_ENG = 1


        NEOSPEECH_MIYU_JPN = 0

        NEOSPEECH_SHOW_JPN = 1

        NEOSPEECH_MISAKI_JPN = 2


        NEOSPEECH_LILY_CHI = 0

        NEOSPEECH_WANG_CHI = 1


        NEOSPEECH_JUNWOO_KOR = 3

        NEOSPEECH_SUJIN_KOR = 8

        NEOSPEECH_YUMI_KOR = 10

        NEOSPEECH_GYURI_KOR = 11

        NEOSPEECH_DAYOUNG_KOR = 12

    End Enum



    Public Const NEOSPEECH_KATE_ENG_NAMESTR As String = "Kate"

    Public Const NEOSPEECH_PAUL_ENG_NAMESTR As String = "Paul"


    Public Const NEOSPEECH_MIYU_JPN_NAMESTR As String = "Miyu"

    Public Const NEOSPEECH_SHOW_JPN_NAMESTR As String = "Show"

    Public Const NEOSPEECH_MISAKI_JPN_NAMESTR As String = "Misaki"


    Public Const NEOSPEECH_LILY_CHI_NAMESTR As String = "Lily"

    Public Const NEOSPEECH_WANG_CHI_NAMESTR As String = "Wang"


    Public Const NEOSPEECH_JUNWOO_KOR_NAMESTR As String = "Junwoo"

    Public Const NEOSPEECH_SUJIN_KOR_NAMESTR As String = "Sujin"

    Public Const NEOSPEECH_YUMI_KOR_NAMESTR As String = "Yumi"

    Public Const NEOSPEECH_GYURI_KOR_NAMESTR As String = "Gyuri"

    Public Const NEOSPEECH_DAYOUNG_KOR_NAMESTR As String = "Dayoung"

    'Messages used for speech events
    Public Const WM_USER As Integer = 1024

    Public Const WIN_SPEAK_MSG As Integer = WM_USER + 12359

    Public Const WIN_EXPORT_MSG As Integer = WM_USER + 12360

#End Region

#Region "P/Invoke declarations"


    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function GetDFTTSVoice(ByVal iVoiceInfoIdIn As Integer, _
                                                    ByRef pvetOut As Integer, _
                                                    ByVal szVoiceNameOut() As Byte, _
                                                    ByRef piVoiceNameLenOut As Integer, _
                                                    ByRef piVoiceIDOut As Integer, _
                                                    ByRef plangOut As Integer _
                                                    ) As Integer

    End Function


    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
   Public Shared Sub InitDFTTSEngineEx3(ByVal hwndWinOwner As IntPtr, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathKate As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal zNeoSpeechDBFolderPathPaul As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathMiyu As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathShow As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathMisaki As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathLily As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathWang As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathJunwoo As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathSujin As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathYumi As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathGyuri As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechDBFolderPathDayoung As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathKate As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathPaul As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathMiyu As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathShow As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathMisaki As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathLily As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathWang As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathJunwoo As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathSujin As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathYumi As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathGyuri As System.String, _
          <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePathDayoung As System.String, _
          ByVal psiLoadedEngines() As Integer, _
          ByVal psiLoadedEnginesReturnValues() As Integer _
          )

    End Sub

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function UninitDFTTSEngine() As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function MakeLanguage(ByVal mainlang As Integer, _
                                        ByVal sublang As Integer _
                                        ) As Integer

    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function GetMainLanguage(ByVal lang As Integer) As Integer

    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function GetSubLanguage(ByVal lang As Integer) As Integer

    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function LoadDFTTSUserDict(ByVal iDictIndex As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szDictName As System.String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szDictFileName As System.String, _
        ByVal vet As Integer, _
        ByVal lang As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szVoiceName As System.String, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szDictContents As System.String) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function UnloadDFTTSUserDict(ByVal iDictIndex As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szDictName As System.String, _
        ByVal vet As Integer, _
        ByVal lang As Integer) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DFTTSSpeak(ByVal hwndWinOwner As IntPtr, _
        ByVal vet As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szVoiceName As System.String, _
        ByVal iVoiceID As Integer, ByVal lang As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szText As System.String, _
        ByVal iPitch As Integer, ByVal iSpeed As Integer, _
        ByVal iVolume As Integer, _
        ByVal iPause As Integer, _
        ByVal iDictID As Integer, _
        ByVal ttTextType As Integer, _
        ByVal ofOutPutFormat As Integer) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DFTTSPause(ByVal vet As Integer, ByVal lang As Integer) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DFTTSResume(ByVal vet As Integer, ByVal lang As Integer) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DFTTSStop(ByVal vet As Integer, ByVal lang As Integer) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DFTTSExportToFileEx(ByVal vet As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szVoiceName As System.String, _
        ByVal iVoiceID As Integer, _
        ByVal lang As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szText As System.String, _
        ByVal iPitch As Integer, _
        ByVal iSpeed As Integer, _
        ByVal iVolume As Integer, _
        ByVal iPause As Integer, _
        ByVal iDictID As Integer, _
        ByVal ttTextType As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szFilePath As System.String, _
        ByVal ffFileFormat As Integer, _
        <MarshalAs(UnmanagedType.LPStr)> ByVal szAudioEncoding As System.String, _
        ByVal iAudioSamplingRate As Integer, _
        ByVal iAudioChannels As Integer) As Integer
    End Function

    <DllImport("dftts.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function GetDFTTSEngineInfo(ByVal vetVType As Integer, ByVal lang As Integer, ByVal ttspParam As Integer, ByVal iValue As Integer(), <MarshalAs(UnmanagedType.LPStr)> ByVal szNeoSpeechLicFilePath As System.String) As Integer
    End Function


#End Region

#Region "Private Variables"

    Private hWnd As IntPtr

    Private bIsPaused As Boolean = False

    Private ascii As New System.Text.ASCIIEncoding()

    'Change this to your preference
    Private sExportFileName As String = "test.wav"

    'We use this class to add to the ComboBox Items (it must override toString())
    Private Class cVoiceData

        Public vet As Integer
        Public lang As Integer
        Public sVoiceName As String
        Public iVoiceId As Integer

        Public Overrides Function toString() As String
            Return sVoiceName
        End Function

    End Class

#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        hWnd = Me.Handle

        Dim iLoadedEngines(NUM_ENGINE_INITIALIZATIONS - 1) As Integer

        Dim iLoadedEnginesReturnValues(NUM_ENGINE_INITIALIZATIONS - 1) As Integer

        For i As Integer = 0 To NUM_ENGINE_INITIALIZATIONS - 1

            iLoadedEngines(i) = CType(DFTTSVoiceEngineType.NOENGINE, Integer)

            iLoadedEnginesReturnValues(i) = CType(InitDFTTSEngineReturnValue.INIT_DFTTS_ENGINE_ERROR_OTHER, Integer)

        Next

        '(!YOU NEED TO CHANGE THE PATHS TO MATCH YOUR PATHS!)

        'This is order that you should supply paths:

        'Kate
        'Paul           
        'Miyu
        'Show 
        'Misaki 
        'Lily 
        'Wang 
        'Junwoo 
        'Sujin 
        'Yumi 
        'Gyuri 
        'Dayoung  
        'Kate
        'Paul           
        'Miyu
        'Show 
        'Misaki 
        'Lily 
        'Wang 
        'Junwoo 
        'Sujin 
        'Yumi 
        'Gyuri 
        'Dayoung  


        InitDFTTSEngineEx3(hWnd, _
           "C:\***", _
           "C:\Program Files\VW\VT\Paul\M16", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\Program Files\VW\VT\Paul\M16\data-common\verify\verification.txt", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           "C:\***", _
           iLoadedEngines, _
           iLoadedEnginesReturnValues _
         )

        'Catch load errors

        Dim sEngineName As String
        sEngineName = ""

        Dim result As InitDFTTSEngineReturnValue

        Dim sNeospVoiceNames(NEOSPEECH_NUM_VOICES - 1) As String

        sNeospVoiceNames(0) = NEOSPEECH_KATE_ENG_NAMESTR
        sNeospVoiceNames(1) = NEOSPEECH_PAUL_ENG_NAMESTR
        sNeospVoiceNames(2) = NEOSPEECH_MIYU_JPN_NAMESTR
        sNeospVoiceNames(3) = NEOSPEECH_SHOW_JPN_NAMESTR
        sNeospVoiceNames(4) = NEOSPEECH_MISAKI_JPN_NAMESTR
        sNeospVoiceNames(5) = NEOSPEECH_LILY_CHI_NAMESTR
        sNeospVoiceNames(6) = NEOSPEECH_WANG_CHI_NAMESTR
        sNeospVoiceNames(7) = NEOSPEECH_JUNWOO_KOR_NAMESTR
        sNeospVoiceNames(8) = NEOSPEECH_SUJIN_KOR_NAMESTR
        sNeospVoiceNames(9) = NEOSPEECH_YUMI_KOR_NAMESTR
        sNeospVoiceNames(10) = NEOSPEECH_GYURI_KOR_NAMESTR
        sNeospVoiceNames(11) = NEOSPEECH_DAYOUNG_KOR_NAMESTR


        For intI As Integer = 0 To NUM_ENGINE_INITIALIZATIONS - 1



            If iLoadedEngines(intI) = CInt(DFTTSVoiceEngineType.NEOSPEECHVOICETEXT) Then


                sEngineName = "NEOPSEECHVOICETEXT Engine Load Result for voice " & _
                    sNeospVoiceNames(intI) & ": "


            ElseIf iLoadedEngines(intI) = CInt(DFTTSVoiceEngineType.CEPSTRAL) Then


                sEngineName = "CEPSTRAL Engine Load Result: "


            ElseIf iLoadedEngines(intI) = CInt(DFTTSVoiceEngineType.ATTNV) Then


                sEngineName = "ATTNV (INTERNAL USE ONLY) Engine Load Result: "

            ElseIf iLoadedEngines(intI) = CInt(DFTTSVoiceEngineType.MACOSXSPMAN) Then


                sEngineName = "MACOSXSPMAN (MAC OS X ONLY) Engine Load Result: "


            ElseIf iLoadedEngines(intI) = CInt(DFTTSVoiceEngineType.MSSAPI) Then


                sEngineName = "MSSAPI (UNMAMAGED SDK USAGE ONLY) Engine Load Result: "

            End If

            result = CType(iLoadedEnginesReturnValues(intI), InitDFTTSEngineReturnValue)

            Debug.Write(sEngineName & result & vbNewLine)

        Next


        'This is how to list all installed supported voices

        Dim szVoiceName As String = "*************************************************************"

        Dim bVoiceName2() As Byte = New Byte(szVoiceName.Length) {}
        ascii.GetBytes(szVoiceName.ToCharArray(), 0, szVoiceName.Length, bVoiceName2, 0)


        Dim iVoiceNameLen As Integer
        iVoiceNameLen = 0

        Dim vet As Integer
        vet = 0

        Dim lang As Integer
        lang = 0

        Dim iVoiceID As Integer
        iVoiceID = 0

        Dim z As Integer
        z = 0

        Dim iUsedNumOfVoices As Integer
        iUsedNumOfVoices = 0

        Do While 0 = 0

            Dim viresult As DFTTSVoiceInfoReturnValue

            viresult = GetDFTTSVoice( _
                z, vet, bVoiceName2, iVoiceNameLen, _
                iVoiceID, lang)

            'DO NOT USE MSSAPI NATIVELY FROM .NET! IT WILL CRASH THE APP!!!
            If viresult = DFTTSVoiceInfoReturnValue.GET_DFTTS_VI_SUCCESS _
                    And vet <> DFTTSVoiceEngineType.MSSAPI Then


                iUsedNumOfVoices = iUsedNumOfVoices + 1

                Dim sVNameOut As String = ascii.GetString(bVoiceName2, 0, iVoiceNameLen)

                Dim oVData As cVoiceData = New cVoiceData
                oVData.vet = vet
                oVData.lang = lang
                oVData.sVoiceName = sVNameOut
                oVData.iVoiceId = iVoiceID

                ComboBox1.Items.Add(oVData)

            Else

                Exit Do

            End If

            z = z + 1

        Loop

        ComboBox1.SelectedIndex = 0

        If iUsedNumOfVoices = 0 Then
            MessageBox.Show("No voices can be found on your system! Please download and install at least 1 voice!")
        End If

        Dim dictreturn As LoadDFTTSUserDictReturnValue

        'User Dictionary Loading: 
        '(read dictionary documentation per engine located in folder DictionarySystems)

        'This is how to load a dictionary for the NeoSpeech provider (the dictionary is loaded _
        'by language from a file (see file in exe directory) (the dict name, voice name, _
        'dict content do NOT matter), the dictionary number matters)

        'MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US) = 1033 - You can just use 1033

        'dictreturn = LoadDFTTSUserDict(1, vbNullString, _
        '         "neospeech_userdict_eng.csv", _
        '        DFTTSVoiceEngineType.NEOSPEECHVOICETEXT, _
        '         MakeLanguage(LANG_ENGLISH, SUBLANG_ENGLISH_US), _
        '        vbNullString, vbNullString)

        'This is how to load a dictionary for the Cepstral provider (the dictionary is loaded
        'by voice from a file (see file in exe directory);
        'The dictionary number, dict name, dict content do NOT matter.)

        'dictreturn = LoadDFTTSUserDict(-1, vbNullString, _
        '         "cepstral_dictionary.txt", _
        '         DFTTSVoiceEngineType.CEPSTRAL, LANG_SUBLANG_NEUTRAL, _
        '        "David", vbNullString)

        If dictreturn <> LoadDFTTSUserDictReturnValue.LOAD_USER_DICT_SUCCESS Then
            MessageBox.Show("SDK Load Dictionary failed with error: " & dictreturn, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If



    End Sub

    Private Sub Form1_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed

        'Stop the voice if it is speaking
        Dim iSelIndex As Integer = ComboBox1.SelectedIndex

        Dim oVData As cVoiceData = ComboBox1.Items.Item(iSelIndex)

        Dim result As DFTTSStopReturnValue = DirectCast(DFTTSStop(oVData.vet, oVData.lang), _
            DFTTSStopReturnValue)

        UninitDFTTSEngine()

    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click

        Dim iSelIndex As Integer = ComboBox1.SelectedIndex

        Dim oVData As cVoiceData = ComboBox1.Items.Item(iSelIndex)


        Dim result As DFTTSSpeakReturnValue = DirectCast(DFTTSSpeak(hWnd, _
        oVData.vet, oVData.sVoiceName, oVData.iVoiceId, oVData.lang, textBox1.Text, _
         -1, -1, -1, -1, 1, CInt(DFTTSTextType.DFTTS_TEXT_TYPE_XML), -1), DFTTSSpeakReturnValue)


        If result <> DFTTSSpeakReturnValue.DFTTS_SPEAK_SUCCESS Then

            MessageBox.Show("SDK Speak error: " & result.ToString(), "Error")

        End If

    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click

        Dim iSelIndex As Integer = ComboBox1.SelectedIndex

        Dim oVData As cVoiceData = ComboBox1.Items.Item(iSelIndex)

        If bIsPaused Then

            bIsPaused = False

            Dim result As DFTTSResumeReturnValue = DirectCast(DFTTSResume(oVData.vet, oVData.lang), _
                DFTTSResumeReturnValue)

            If result <> DFTTSResumeReturnValue.DFTTS_RESUME_SUCCESS Then

                MessageBox.Show("SDK Resume error: " & result.ToString(), "Error")

            End If

        ElseIf bIsPaused = False Then

            bIsPaused = True

            Dim result As DFTTSPauseReturnValue = DirectCast(DFTTSPause(oVData.vet, oVData.lang), _
                DFTTSPauseReturnValue)

            If result <> DFTTSPauseReturnValue.DFTTS_PAUSE_SUCCESS Then

                MessageBox.Show("SDK Pause error: " & result.ToString(), "Error")

            End If
        End If

    End Sub

    Private Sub button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button4.Click

        Dim iSelIndex As Integer = ComboBox1.SelectedIndex

        Dim oVData As cVoiceData = ComboBox1.Items.Item(iSelIndex)

        Dim result As DFTTSStopReturnValue = DirectCast(DFTTSStop(oVData.vet, oVData.lang), _
            DFTTSStopReturnValue)

        If result <> DFTTSStopReturnValue.DFTTS_STOP_SUCCESS Then

            MessageBox.Show("SDK Stop error: " & result.ToString(), "Error")

        End If

    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click

        Dim iSelIndex As Integer = ComboBox1.SelectedIndex

        Dim oVData As cVoiceData = ComboBox1.Items.Item(iSelIndex)

        Dim result As DFTTSExportReturnValue = DirectCast( _
            DFTTSExportToFileEx(oVData.vet, _
            oVData.sVoiceName, _
            oVData.iVoiceId, _
            oVData.lang, _
            textBox1.Text, -1, _
            -1, -1, -1, -1, _
            CInt(DFTTSTextType.DFTTS_TEXT_TYPE_PLAIN), _
            sExportFileName, _
            CInt(NeoSpeechVoiceTextAudioFormat.VT_FILE_API_FMT_ALAW_WAVE), _
            "pcm16", 16000, 2), DFTTSExportReturnValue)


        If result <> DFTTSExportReturnValue.DFTTS_EXPORT_SUCCESS Then

            MessageBox.Show("SDK Export error: " + result.ToString(), "Error")

        End If

    End Sub

    'How to capture OnWord and OnExportFinished events:
    Protected Overloads Overrides Sub WndProc(ByRef m As Message)
        Select Case m.Msg
            Case WIN_SPEAK_MSG
                Dim sb As New StringBuilder()
                sb.Append("OnWord: Start Character: ")
                sb.Append(m.WParam)
                sb.Append(", End Character: ")
                sb.Append(CInt(m.LParam))

                Me.label1.Text = sb.ToString()
                Exit Select
            Case WIN_EXPORT_MSG

                MessageBox.Show("Export succesful!", "Success")
                Exit Select
            Case Else

                MyBase.WndProc(m)
                Exit Select
        End Select

    End Sub


End Class
